(function() {
  var i, ifc;

  i = require("./icon");

  ifc = {
    template: i.template,
    mixins: i.mixins,
    data: function() {
      return {
        style: null
      };
    },
    ready: function() {
      return this.style = window.getComputedStyle(this.$el);
    },
    props: {
      name: i.props.name,
      flip: i.props.flip,
      label: i.props.label
    },
    computed: {
      icon: i.computed.icon,
      box: i.computed.box,
      flipped: i.computed.flipped,
      height: function() {
        if (this.style) {
          return parseFloat(this.style.getPropertyValue("font-size").replace("px", ""));
        }
        return null;
      },
      width: function() {
        return this.icon.w / this.icon.h * this.height;
      },
      marginTop: function() {
        return null;
      }
    }
  };

  module.exports = ifc;

}).call(this);
