getIcons();

module.exports = {
  mixins: [require("vue-mixins/vue"), require("vue-mixins/setCss")],
  props: {
    name: {
      type: String,
      required: true
    },
    size: {
      type: String,
      "default": "16"
    },
    scale: {
      type: String,
      "default": "1"
    },
    flip: String,
    label: String,
    hcenter: {
      type: Boolean,
      "default": false
    }
  },
  data: function() {
    return {
      parent: null
    };
  },
  ready: function() {
    this.parent = this.$el.parentElement;
    return this.marginTop;
  },
  computed: {
    icon: function() {
      var set, tmp;
      tmp = this.name.split("-");
      set = tmp.shift();
      return getIcon(set, this.Vue.util.camelize(tmp.join("-")));
    },
    box: function() {
      var s;
      if (this.flip === "h") {
        s = "0 -" + this.icon.h;
      } else if (this.flip === "v") {
        s = "-" + this.icon.w + " 0";
      } else {
        s = "0 0";
      }
      return s + (" " + this.icon.w + " " + this.icon.h);
    },
    width: function() {
      return this.icon.w / this.icon.h * this.height;
    },
    height: function() {
      return parseFloat(this.size) * parseFloat(this.scale);
    },
    flipped: function() {
      if (this.flip === "h") {
        return "scale(1,-1)";
      } else if (this.flip === "v") {
        return "scale(-1,1)";
      } else {
        return null;
      }
    },
    marginTop: function() {
      if (this.hcenter && (this.parent != null)) {
        this.setCss(this.$el, "line-height", this.parent.clientHeight + "px");
      } else {
        this.setCss(this.$el, "line-height");
      }
      return null;
    }
  }
};

if (module.exports.__esModule) module.exports = module.exports.default
;(typeof module.exports === "function"? module.exports.options: module.exports).template = "<span><svg version=1.1 :role=\"label ? 'img' : 'presentation'\" :aria-label=label :width=width :height=height :view-box.camel=box display=inline-block><path :d=icon.d :transform=flipped fill=currentColor></path></svg><slot></slot></span>"
